package orig.plotter;

/**
 * Simulator for a multi-pen plotter.
 * 
 * @author evensen
 * 
 */
public interface Plotter {
	/**
	 * Fetches and changes to a different coloured pen.
	 * 
	 * Lifts the pen, moves the pen-head to the pen storage and stops there.
	 * 
	 * @param color
	 */
	public void setPenColor(PenColor color);

	/**
	 * Lifts the pen and moves to the origin of the paper.
	 */
	public void home();

	/**
	 * Lowers or lifts the pen.
	 * 
	 * @param v
	 *            <code>true</code> lowers the pen, <code>false</code> lifts it.
	 */
	public void penDown(boolean v);

	/**
	 * Moves (and possibly draws, if the pen is down) from the current position to the coordinate
	 * given as <x1, y1>.
	 * 
	 * @param x1
	 *            ,y1 the coordinate to move to.
	 */
	public void moveTo(int x1, int y1);
}
