package calendarapp.gui;

import java.awt.Dimension;
import java.awt.GridBagLayout;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

import calendarapp.plugins.PluginArea;


/**
 * The main view.
 * @author adamw
 *
 */
@SuppressWarnings("serial")
public class MainWindow extends JFrame {
	private Calendar calendar = new Calendar();

	//TODO B5: Use the newly defined PluginArea instead of PluginPanel.NORTH/SOUTH.
	private PluginPanel northPluginArea = new PluginPanel(PluginPanel.NORTH);
	private PluginPanel southPluginArea = new PluginPanel(PluginPanel.SOUTH);

	public MainWindow() {
		GridBagLayout layout = new GridBagLayout();
		getContentPane().setLayout(layout);

		this.setMinimumSize(new Dimension(640, 480));
		setSize(900, 675);

		setTitle("The 1984 Calendar - Was Orwell wrong?");
		setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

		// The three different areas are added to the main view.
		getContentPane().add(northPluginArea, northPluginArea.getConstraints());
		getContentPane().add(calendar, calendar.getConstraints());
		getContentPane().add(southPluginArea, southPluginArea.getConstraints());
	}
}