package calendarapp.gui;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.util.List;

import javax.swing.JPanel;

import calendarapp.plugins.GUIPlugin;
import calendarapp.plugins.Pluggable;
import calendarapp.plugins.PluginArea;
import calendarapp.plugins.PluginLoader;


/**
 * Describes a plugin panel. This is an area where GUI plugins can be appended.
 * @author adamw
 *
 */
@SuppressWarnings("serial")
public class PluginPanel extends JPanel implements Constrained {
	// TODO B4: Remove the use of the NORTH and SOUTH static
	// variables and use the newly defined PluginArea instead to define
	// the PluginArea in this class. You will of course have to change
	// the constructor and references below as well.
	public final static int NORTH = 1;
	public final static int SOUTH = 1;

	private int pluginArea;
	
	PluginPanel(int pluginArea) {
		this.pluginArea = pluginArea;
		addPlugins();
	}

	private void addPlugins() {
		List<Pluggable<?>> plugins = PluginLoader.loadGUIPlugins();

		// TODO F1: Loop through the returned plugins and call the plugin.get() method to
		// fetch the widget from the plugin and add it to this panel. You should do a few
		// things BEFORE adding the widget to this panel:
		// 1. Make sure the area of the plugin is truly intended for this plugin area.
		//    You can get that information from the annotation attached to the plugin.
		// 2. Make sure plugin.get() returns a Swing Component or a subclass thereof.
		// 3. Call plugin.configure().
	}

	public GridBagConstraints getConstraints() {
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.gridwidth = 4;
		constraints.gridy = pluginArea == NORTH ? 0 : 2;

		return constraints;
	}
}
