package edu.chl.hajo.monopoly.core;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.Random;

import edu.chl.hajo.monopoly.constants.GameEvents;
import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.util.IObservable;

/**
 * A Pair of dices. Replaces Dice class
 * 
 * @author hajo
 * 
 */
public class Dices implements IObservable{

	private final PropertyChangeSupport observers = new PropertyChangeSupport(
			this);
	private static final Random r = new Random();
	private int fst = 0;
	private int sec = 0;

	public int roll() {
		fst = r.nextInt(6) + 1;
		sec = r.nextInt(6) + 1;
		observers.firePropertyChange(
				StateChanges.DICE_FST_THROWN.toString(), null, fst);
		observers.firePropertyChange(
				StateChanges.DICE_SEC_THROWN.toString(), null, sec);
		// Not a state change just something that can happen
		if (fst == sec) {
			observers.firePropertyChange(GameEvents.DICES_EQUAL.toString(),
					null, null);		
		}
		// TODO remove
		System.out.println("Dices " + fst + " " + sec);
		return fst + sec;
	}

	@Override
	public void addObserver(PropertyChangeListener observer) {
		observers.addPropertyChangeListener(observer);
	}
}
