package edu.chl.hajo.monopoly.core.space;

import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.core.Player;

//import edu.chl.hajo.monopoly.util.IVisitor;

/**
 * Class represents a space that can be owned (has price and rent)i.e.
 * 
 * - Water or Electricity (Utility) - Railroads
 * 
 * @author hajo
 * 
 */
public class Property extends AbstractSpace {

	protected int rent;
	protected Player owner = null;
	protected int price = 500;

	public Property(String name) {
		super(name);
	}

	public int getPrice() {
		return price;
	}

	public void setOwner(Player owner) {
		this.owner = owner;
		if (owner == null) {
			observers.firePropertyChange(
					StateChanges.PROPERTY_LOST_OWNER.toString(), null, null);
		} else {
			observers.firePropertyChange(
					StateChanges.PROPERTY_GOT_OWNER.toString(), null, owner);
		}
	}

	public Player getOwner() {
		return owner;
	}

	public boolean hasOwner() {
		return owner != null;
	}

}
