package edu.chl.hajo.monopoly.io;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * To read simple flat text files line by line
 * @author hajo
 *
 */
public class FileReader implements IFileReader {

	public List<String> readDataFile(String fileName) {
		List<String> strs = new ArrayList<String>();
		Scanner scanner = null;
		try {
			scanner = new Scanner(new FileInputStream(fileName));
			try {
				while (scanner.hasNextLine()) {
					String s = scanner.nextLine().trim();
					if (s.length() == 0) {
						// Skip empty lines
					} else if (s.matches("#.*")) {
						// Skip comments in file
					} else {
						strs.add(s);
					}
				}
			} finally {
				scanner.close();
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return strs;
	}

	private FileReader() {
	}

	private static FileReader instance = null;

	public static IFileReader getInstance() {
		if (instance == null) {
			instance = new FileReader();
		}
		return instance;
	}
}
