package edu.chl.hajo.monopoly.rules;

import edu.chl.hajo.monopoly.core.Game;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Property;

/**
 * Helper class to check preconditions for buy and sell and more
 * @author hajo
 *
 */
public class Rules {
	
	private static Player getPlayer(){
		return Game.getInstance().getActualPlayer();
	}
	
	// The owner is actual player
	public static boolean sellPropertyEnabled(Property property){
		return property.hasOwner() && property.getOwner() == getPlayer();
	}
	
	// No one owns space and player is visiting the space
	public static boolean buyEnabled(Property property){
		return !property.hasOwner() && property.isVisitingPlayer(getPlayer());
	}
}
