package edu.chl.hajo.monopoly;

import org.junit.Assert;
import org.junit.Test;

import edu.chl.hajo.monopoly.constants.Piece;
import edu.chl.hajo.monopoly.core.Board;
import edu.chl.hajo.monopoly.core.Player;

/**
 * Testing some core classes
 * 
 * NOTE: It's possible to debug the controls !!!
 * 
 * @author hajo
 * 
 */
public class TestCore {

	
	// Must have and use file resources/spacesData.txt
	@Test
	public void testBoard() {
		Board b = new Board();
		Assert.assertTrue(b.getSpaces().size() == 40);
		Assert.assertTrue(b.getSpaces().get(0).getName().equals("go"));
	}

	@Test
	public void testPlayer() {
		Player p = new Player("name", Piece.DOG);

		Assert.assertTrue(p.getPosition() == 0);
		p.move(5);
		Assert.assertTrue(p.getPosition() == 5);

		p.moveTo(0);
		Assert.assertTrue(p.getPosition() == 0);

		p.move(40);
		Assert.assertTrue(p.getPosition() == 0);
	}

}
