package edu.chl.hajo.monopoly;

import java.io.FileNotFoundException;
import java.lang.reflect.InvocationTargetException;

import edu.chl.hajo.monopoly.build.GameBuilder;
import edu.chl.hajo.monopoly.core.Game2;
import edu.chl.hajo.monopoly.core.Locator;
import edu.chl.hajo.monopoly.view.GUIBuilder;
import edu.chl.hajo.monopoly.view.MainFrame;

/**
 * Application entry point.
 * @author hajo
 * 
 */
public class Main {

	public static void main(String[] args) {
		// TODO Possible args to files
		
		try {
			// Using builder to separate out the build process from the model
			GameBuilder gameBuilder = new GameBuilder();
			Game2 game = gameBuilder.build();
			MainFrame mainFrame = new GUIBuilder(gameBuilder).build();
			Locator.set(game);
			mainFrame.setVisible(true);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
