package edu.chl.hajo.monopoly.core;

import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.core.space.Street;

/**
 * Helper class to check rules for buy and sell and more
 * Used by model and GUI
 * @author hajo
 *
 */
public class Rules implements IRules{

	// The owner is actual player
	public boolean sellPropertyEnabled(Property property, IPlayer player) {
		return property.getOwner() == player;
	}

	public boolean buyEnabled(Property property, IPlayer player) {
		// TODO 
		return !property.hasOwner() && property.isVisitingPlayer((Player)player);
	}

	// The owner is actual player and no buildings
	public boolean sellStreetEnabled(Street street, IPlayer player) {
		return sellPropertyEnabled(street, player) && street.getNrOfBuildings() == 0;
	}

	public boolean buyBuildingEnabled(Street street, IPlayer player) {
		return sellPropertyEnabled(street, player) && street.getNrOfBuildings() < 5;
	}

	public boolean sellBuildingEnabled(Street street, IPlayer player) {
		return sellPropertyEnabled(street, player) && street.getNrOfBuildings() > 0;
	}

}
