package edu.chl.hajo.monopoly.io;

import java.io.FileNotFoundException;
import java.util.List;

import edu.chl.hajo.monopoly.constants.Constants;

/**
 * 
 *  Utility to get text and actions for the chance and
 *  community spaces. Simulating the Card classes.
 * 
 * Data format
 * text:action:arg
 * 
 * text:
 * String to display
 * 
 * action: 
 * withdraw
 * addIncome
 * move
 * moveTo
 * getFromAll
 * 
 * arg:
 * numerical
 * 
 * @author hajo
 *
 */
public class ChanceCommunityResources {

	private static List<String> cardData; 
	
	static{
		try {
			cardData = FileReader.getInstance().readDataFile(Constants.CARD_DATA_FILE);
		} catch (FileNotFoundException e) {
			// TODO fire event
			e.printStackTrace();
		}
	}
	private static int i = 0;
	
	/*
	 * The text for the card, the action and parameters to action
	 * if any
	 */
	public static String getNextCardData() {
		return cardData.get(++i % cardData.size());
	}
}
