package edu.chl.hajo.monopoly.view;

import java.awt.Color;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly.core.Dices;
import edu.chl.hajo.monopoly.event.GameEvents;
import edu.chl.hajo.monopoly.event.StateChanges;


/**
 * The view of the Dices
 * 
 * NOTE: Static GUI already connected to EventBus
 */
@SuppressWarnings("serial")
public class DicesPanel extends JPanel implements PropertyChangeListener{
	private JLabel jLblDiceFst;
	private JLabel jLblDiceSec;
	
	public DicesPanel(Dices dices) {
		initGUI();
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		String e = evt.getPropertyName();
		if( e.equals(StateChanges.DICE_FST_THROWN.toString())){
			jLblDiceFst.setText(String.valueOf(evt.getNewValue()) + "   ");
		}else if ( e.equals(StateChanges.DICE_SEC_THROWN.toString())){
			jLblDiceSec.setText(String.valueOf(evt.getNewValue()));
		}else if ( e.equals(GameEvents.NEW_GAME.toString())){
			jLblDiceFst.setText(" 0 ");
			jLblDiceSec.setText(" 0 ");
		}
		
	}
	
	private void initGUI() {
		try {
			{
				this.setBackground(Color.YELLOW);
				{
					jLblDiceFst = new JLabel();
					this.add(jLblDiceFst);
					jLblDiceFst.setText("jLblDieFst");
					jLblDiceFst.setFont(new java.awt.Font("Dialog",0,24));
				}
				{
					jLblDiceSec = new JLabel();
					this.add(jLblDiceSec);
					jLblDiceSec.setText("jblDiceSec");
					jLblDiceSec.setFont(new java.awt.Font("Dialog",0,24));
				}
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
}
