package edu.chl.hajo.monopoly.view.dialog;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.WindowConstants;

/**
 * Base class for game event dialogs (show when event occur)
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public abstract class AbstractEventDialog extends JDialog {
	protected JLabel jLblText;
	private JButton jBtnOk;
	
	
	public AbstractEventDialog(JFrame parent) {
		this.setPreferredSize(new Dimension(100,100));
		this.setLocationRelativeTo(parent);
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		// TODO this.setTitle(g.getActualSpace().getName());  // TODO Needed
		initGUI();
		initCtrl();
		
	}

	protected abstract void execute();
	
	private void initCtrl() {
		jBtnOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				execute();
			}
		});
	}
	
	private void initGUI() {
		try {
			FlowLayout thisLayout = new FlowLayout();
			getContentPane().setLayout(thisLayout);
			this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			{
				jLblText = new JLabel();
				getContentPane().add(jLblText);
				jLblText.setText("jLblText");
			}
			{
				jBtnOk = new JButton();
				getContentPane().add(jBtnOk);
				jBtnOk.setText("jBtnOk");
			}
			{
				this.setSize(348, 244);
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

}
