package edu.chl.hajo.monopoly.view;

import java.awt.Color;
import java.awt.Graphics;
import java.beans.PropertyChangeEvent;

import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.util.Options;
import edu.chl.hajo.monopoly.view.details.PropertyDetails;

/**
 * View of Property
 * @author hajo
 */
@SuppressWarnings("serial")
public class PropertyPanel extends AbstractSpacePanel {

	private Property property;
	protected Color backGround = this.getBackground();
	
	protected void showDetails() {
		new PropertyDetails(this, property).setVisible(true);
	}

	public PropertyPanel(Property property) {
		super(property);
		this.property = property;
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		super.propertyChange(evt);
		String name = evt.getPropertyName();
		if (StateChanges.PROPERTY_GOT_OWNER.toString().equals(name)) {
			Player p = property.getOwner();
			Color c = Options.getColorForPiece(p.getPiece());
			this.setBackground(c);
		} else if (StateChanges.PROPERTY_LOST_OWNER.toString().equals(name)) {	
			this.setBackground(backGround);
		}
	}
	
	@Override
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
	}
}
