package edu.chl.hajo.monopoly.view.details;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.view.PlayerPanel;

/**
 * Detailed view of Player
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class PlayerDetails extends JDialog {
	
	private JButton jBtnOk;
	private JPanel jPnlProperties;
	private JPanel jPnlControl;
	private Player player;

	public PlayerDetails(PlayerPanel parent, Player player) {
		this.player = player;
		this.setLocationRelativeTo(parent);
		this.setTitle(player.getName());
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		initGUI();
		initPropertiesPanel();
	}
	
	private void initGUI(){
		this.setSize(new Dimension(100,100));
		this.setLayout(new BorderLayout());
		Container c = this.getContentPane();
		jBtnOk = new JButton("OK");
		jPnlProperties = new JPanel();
		jPnlControl = new JPanel();
		c.add(jPnlProperties, BorderLayout.CENTER);
		c.add(jPnlControl, BorderLayout.SOUTH);
		jPnlControl.add(jBtnOk);
		
	}
	
	private void initPropertiesPanel() {
		List<Property> props = player.getProperties();
		for (Property p : props) {
			JButton b = new JButton(p.getName());
			b.addActionListener(new Listener(p));
			jPnlProperties.add(b);
		}
	}
	
	private static class Listener implements ActionListener {

		private Property p;

		public Listener(Property p) {
			this.p = p;
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			DetailsVistor df = new DetailsVistor();
			p.visit(df);
			df.getDetails().setVisible(true);
		}
	};
	
}
