package edu.chl.hajo.monopoly.view.dialog;

import javax.swing.JFrame;

import edu.chl.hajo.monopoly.core.space.NonProperty;
import edu.chl.hajo.monopoly.ctrl.CF;
import edu.chl.hajo.monopoly.io.ChanceCommunityResources;

/**
 * Event dialog for NonProperty fired events
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class NonPropertyEventDialog extends AbstractEventDialog {

	private NonProperty np;
	private String cardData;

	public NonPropertyEventDialog(JFrame parent, NonProperty np) {
		super(parent);
		this.np = np;
		if (np.getName().matches("community|chance")) {
			cardData = ChanceCommunityResources.getNextCardData();
			jLblText.setText(cardData.split(":")[0]);
		} else if (np.getName().equals("gojail")) {
			jLblText.setText("gojail");
		}
	}

	@Override
	protected void execute() {
		if (np.getName().matches("community|chance")) {
			CF.get(CF.Name.CHANCE_COMMUNITY, cardData).execute();
		} else if (np.getName().equals("gojail")) {
			CF.get(CF.Name.GO_JAIL).execute();
		}
		this.dispose();
	}

}
