package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.IGame;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.ctrl.BuyPropertyCtrl;
import edu.chl.hajo.monopoly.ctrl.EndTurnCtrl;
import edu.chl.hajo.monopoly.ctrl.MoveCtrl;
import edu.chl.hajo.monopoly.ctrl.SellPropertyCtrl;

/**
 * An interpreter to run a scenario (not finished
 * just a sketch)
 * A scenario is a string of the form
 * 
 * command:command:command:...
 * 
 * Commands are
 * mN - move actual player N steps (1 <= N <= 99)
 * s - switch actual player
 * bp = buy property
 * sp = sell property
 * etc
 * 
 * @author hajo
 *
 */
public class Interpretator {
	
	private IGame g;
	
	public Interpretator(IGame g){
		this.g = g;
	}

	public void run( String scenario){
		String[] commands = scenario.split(":");
		for( String s : commands){
			if( s.matches("m[0-9]*")){
				String n = s.substring(1);
				System.out.println("move " + n);
				new MoveCtrl(Integer.valueOf(n)).execute();
			} else if( s.equals("s")){
				new EndTurnCtrl().execute();
			} else if( s.equals("bp")){
				Property p = (Property) g.getActualSpace();
				new BuyPropertyCtrl(p).execute();
			} else if( s.equals("sp")){
				Property p = (Property) g.getActualSpace();
				new SellPropertyCtrl(p).execute();
			}
		}
	}
}
