
package edu.chl.hajo.monopoly.core.visitor;

import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Space;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.core.space.Tax;

/**
 * The visitor pattern. Because we put all spaces (and subclasses)
 * in the same collection (a heterogenous collection).
 * We use the visitor pattern (instead of using instanceof)
 * @author hajo
 */
public interface IVisitor {

    public void visit(Space a, Player actual);
    
    public void visit(Property p, Player actual);

    public void visit(Tax t, Player actual);

   
}
