package edu.chl.hajo.monopoly.event;

/**
 * A single event
 *
 * @author hajo
 *
 */
public class Event {

    // All possible events listed
    public enum Tag {

        NEW_GAME, ADD_PLAYER, DICE_RESULT, NEXT, REMOVE_PLAYER, BUY
    }

    private final Tag tag;
    // Data to send
    private final Object value;

    public Event(Tag tag, Object value) {
        this.tag = tag;
        this.value = value;
    }

    public Tag getTag() {
        return tag;
    }

    public Object getValue() {
        return value;
    }

    @Override
    public String toString() {
        return "Event [tag=" + tag + ", value=" + value + "]";
    }
}
