package edu.chl.hajo.mply;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import edu.chl.hajo.mply.core.Board;
import edu.chl.hajo.mply.core.Card;
import edu.chl.hajo.mply.core.CardBundle;
import edu.chl.hajo.mply.core.Dice;
import edu.chl.hajo.mply.core.P;
import edu.chl.hajo.mply.core.Piece;
import edu.chl.hajo.mply.core.Player;
import edu.chl.hajo.mply.core.Space;

public class Main {

    public void run() {
        Board board = new Board();
        List<Player> players = new ArrayList<Player>();
        players.add(new Player("pelle"));
        players.add(new Player("fia"));

        Piece p1 = new Piece(players.get(0), Piece.Tag.CAR);
        Piece p2 = new Piece(players.get(1), Piece.Tag.DOG);
        CardBundle bundle = new CardBundle();
        Dice d = new Dice(P.INSTANCE.getMaxDice());

        Scanner in = new Scanner(System.in);
        Piece actualPiece = p1;
        System.out.println("MAX DICE is " + P.INSTANCE.getMaxDice());
        while (true) {
            System.out.println(actualPiece.toString());
            dump(board, p1, p2);

            System.out.print(">");
            String line = in.nextLine();

            if (line.equals("m")) { // Move
                if (!actualPiece.isMovable()) {
                    continue;
                }
                Player p = actualPiece.getPlayer();
                int i = p.roll(d);
                actualPiece.move(i);
                System.out.println("Dice: " + i);
                if (i < P.INSTANCE.getMaxDice()) {
                    actualPiece.setMovable(false);
                }
                if (actualPiece.passedGo()) {
                    actualPiece.getPlayer().income(
                            P.INSTANCE.getPassGoIncome());
                }
                while (true) {
                    int oldPos = actualPiece.getPosition();
                    /*
                     * This can change position or state
                     * (make it movable)
                     */ 
                    if(board.getSpace(actualPiece.getPosition()).isCard()){
                        Card c = bundle.getCard();
                        System.out.println("Card: " + c);
                        actualPiece.actOnCard(c); // Moves
                        actualPiece.getPlayer().actOnCard(c); // Other actions
                    } 
                    // Have done this card (no new)
                    if( oldPos == actualPiece.getPosition()){
                        break;
                    } 
                    if (actualPiece.passedGo()) {
                        actualPiece.getPlayer().income(
                                P.INSTANCE.getPassGoIncome());
                    } 
                }
            } else if (line.equals("n")) { // Next
                actualPiece = (actualPiece == p1) ? p2 : p1;
                actualPiece.setMovable(true);
            } else if (line.equals("b")) { // Buy
                Player p = actualPiece.getPlayer();
                if (board.getSpace(actualPiece.getPosition()).getOwner() == null) {
                    p.buy(board.getSpace(actualPiece.getPosition()));
                }
            } else if (line.equals("s")) { // Sell
                Player p = actualPiece.getPlayer();
                if (board.getSpace(actualPiece.getPosition()).getOwner() == p) {
                    p.sell(board.getSpace(actualPiece.getPosition()));
                }
            } else {

            }
        }
    }

    private void dump(Board b, Piece p1, Piece p2) {
        for (Space s : b.getSpaces()) {
            System.out.print(s);
            if (p1.getPosition() == s.getId()) {
                System.out.print(p1.getTag());
            }
            if (p2.getPosition() == s.getId()) {
                System.out.print(p2.getTag());
            }
        }
        System.out.println();
    }

    public static void main(String[] args) {
        new Main().run();
    }
}
