package edu.chl.hajo.mply.core;

import edu.chl.hajo.mply.constants.PieceTag;

/**
 * Piece to move around board
 * @author hajo
 *
 */
public class Piece {

    // Owner
    private final Player player;
    private final PieceTag tag; // TODO inner enum
    private int pos = 0;
    
    public Piece(Player player, PieceTag tag) {
        super();
        this.player = player;
        this.tag = tag;
    }
    
    public void move( int steps ){
        int oldPos = pos;
        pos = (pos + steps) % P.INSTANCE.getMaxSpaces();
        // Max move is 12 (in general)
        if( pos < oldPos ){
            player.income(P.INSTANCE.getPassGoIncome());
        }
    }
     
    public int getPosition(){
        return pos;
    }

    public Player getPlayer() {
        return player;
    }

    public PieceTag getTag() {
        return tag;
    }
}
