package edu.chl.hajo.mply.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

import edu.chl.hajo.mply.core.Monopoly;
import edu.chl.hajo.mply.event.Event;
import edu.chl.hajo.mply.event.EventBus;
import edu.chl.hajo.mply.event.EventHandler;

/**
 * Panel for control buttons (next,...)
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class ControlPanel extends JPanel implements ActionListener,
        EventHandler {

    private JButton next = new JButton("next");

    public ControlPanel() {
        init();
        EventBus.register(this);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        Monopoly.getInstance().next();

    }

    @Override
    public void onEvent(Event evt) {
        if (evt.getTag().equals(Event.Tag.PIECE_MOVABLE)) {
            boolean b = (Boolean) evt.getValue();
            next.setEnabled(!b);
        }
    }

    private void init() {
        next.addActionListener(this);
        add(next);
    }

}
