package edu.chl.hajo.mply.gui;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.chl.hajo.mply.core.Piece;
import edu.chl.hajo.mply.event.Event;
import edu.chl.hajo.mply.event.EventBus;
import edu.chl.hajo.mply.event.EventHandler;

/**
 * Panel for a single Space
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class SpacePanel extends JPanel implements EventHandler {

    List<Piece> visitors = new ArrayList<Piece>();
    private final int id;

    public SpacePanel(int id) {
        this.id = id;
        EventBus.register(this);
        init();
    }

    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.PIECE_OLD_POSITION) {
            Piece p = (Piece) evt.getValue();
            if (p.getPosition() == id) {
                int i = visitors.indexOf(p);
                if (i >= 0) {
                    visitors.remove(i);
                   
                }
            }
        } else if (evt.getTag() == Event.Tag.PIECE_NEW_POSITION) {
            Piece p = (Piece) evt.getValue();
            if (p.getPosition() == id) {
                visitors.add(p);
               
            }
        }
       dump();
       //repaint();
    }

    List<JLabel> ls = new ArrayList<JLabel>();

    private void dump() {
        for (JLabel l : ls) {
            this.remove(l);
        }
        for (Piece p : visitors) {
            JLabel l = new JLabel(p.getTag().toString());
            this.add(l);
            ls.add(l);
        }
       
    }

    private void init() {
        this.setBorder(BorderFactory.createLineBorder(Color.BLACK));

    }

}
