package edu.chl.hajo.mply.observable;

import edu.chl.hajo.mply.core.Card;
import edu.chl.hajo.mply.core.CardBundle;
import edu.chl.hajo.mply.core.Dice;
import edu.chl.hajo.mply.core.P;
import edu.chl.hajo.mply.core.Player;
import edu.chl.hajo.mply.core.Space;
import edu.chl.hajo.mply.event.Event;
import edu.chl.hajo.mply.event.EventBus;

/**
 * Extending a Player with observability (not clutter up model)
 * @author hajo
 *
 */
public class ObservablePlayer extends Player {

    public ObservablePlayer(String name) {
        super(name);
    }

    public void income(int income) {
        super.income(income);
        EventBus.publish(new Event(Event.Tag.PLAYER_BALANCE, super.getBalance()));
    }

    public void expense(int expence) {
        super.expense(expence);
        EventBus.publish(new Event(Event.Tag.PLAYER_BALANCE, super.getBalance()));
    }

    public void pickCard(CardBundle bundle) {
        // TODO doesn't use the card right now
        EventBus.publish(new Event(Event.Tag.CARD, bundle.getCard()));
    }
}
