package monopoly01;

import java.util.List;

/**
 * Class representing the over all game
 * @author hajo
 * 
 */
public class Monopoly01 {

    private final List<Player> players;
    private final Dice dice;
    private final Board board;
    private Player actual;

    // First player will be actual
    public Monopoly01(Dice dice, Board board, List<Player> players) {
        this.dice = dice;
        this.board = board;
        this.players = players;
        actual = players.get(0);
    }

    public void move() {
        dice.roll();
        Piece p = actual.getPiece();
        Space oldPos = p.getPosition();
        Space newPos = board.get(oldPos, dice.getFirst() + dice.getSecond());
        p.setPosition(newPos);
    }
    
    public void endTurn() {
        int i = (players.indexOf(actual) + 1) % players.size();
        actual = players.get(i);
    }

    @Override
    public String toString() {
        StringBuffer b = new StringBuffer();
        b.append(dice.getFirst() + ":" + dice.getSecond());
        b.append("[");
        for (Space s : board.getSpaces()) {
            b.append(s.toString());
            if (actual.getPiece().getPosition() == s) {
                // Just actual printed (others invisible)
                b.append(actual.getPiece());
            }
        }
        b.append("]");
        return b.toString();
    }

}
