package edu.chl.hajo.monopoly04.adapter;

import java.util.Collection;

import edu.chl.hajo.monopoly04.eventbus.Event;
import edu.chl.hajo.monopoly04.eventbus.EventBus;
import edu.chl.hajo.monopoly04.model.Dice;
import edu.chl.hajo.monopoly04.model.IBoard;
import edu.chl.hajo.monopoly04.model.IMonopoly;
import edu.chl.hajo.monopoly04.model.IPlayer;
import edu.chl.hajo.monopoly04.model.Player;
import edu.chl.hajo.monopoly04.model.Space;

public class EventAdapter {

    private final IMonopoly mp;

    public EventAdapter(IMonopoly mp) {
        this.mp = mp;
    }

    //@Override
    public void start() {
        mp.start();
        EventBus.INSTANCE.publish(new Event(Event.Tag.START, null));
        // To force actual to display
        EventBus.INSTANCE.publish(new Event(Event.Tag.END_TURN, mp.getActualPlayer()));
        updateBoard();
    }

    //@Override
    public void move() {
        mp.move();
        updateBoard();
        Dice d = mp.getDice();
        EventBus.INSTANCE.publish(new Event(Event.Tag.UPDATE_DICE, d));
    }

    private void updateBoard() {
        for (Space s : mp.getBoard().getSpaces()) {
            EventBus.INSTANCE.publish(new Event(Event.Tag.UPDATE_SPACE, s));
        }
    }

    //@Override
    public void move(int steps) {

    }

    //@Override
    public void endTurn() {
        mp.endTurn();
        IPlayer p = mp.getActualPlayer();
        EventBus.INSTANCE.publish(new Event(Event.Tag.END_TURN, p));
    }

    //@Override
    public IBoard getBoard() {
        return mp.getBoard();
    }

    //@Override
    public Collection<IPlayer> getPlayers() {
        return mp.getPlayers();
    }

    public IPlayer getActualPlayer() {
        return mp.getActualPlayer();
    }

}
