package guice;

import com.google.inject.Guice;
import com.google.inject.Injector;

/**
 * Testing Google Guice a light weight dependency injection framework
 * @author hajo
 * 
 * GENERAL NOTE: To be able to use injection you can't create
 * objects with 'new'. The objects must be created by the framework,
 * see below.
 *
 */
public class Main {

	public static void main(String[] args) {
		Injector injector = Guice.createInjector(new TestModule());
		Person person = injector.getInstance(Person.class);
		person.diplayInfo();
		Student student = injector.getInstance(Student.class);
		student.diplayInfo();
	}

}
