package rmi;


import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 * NOTE : This test has a Run Configuration
 * (Mark file > Run As ... > Run Configuration > 
 *  x = Argsuments > VM Arguments) 
 * 
 * The following parameters must be passed as VM Arguments
 * -Djava.security.policy=security.policy	
 * 
 * @author hajo
 *
 */
public class TestRMI {

	static IServer s;
	
	// Run once before all tests
	@BeforeClass
	public static void setUp() throws RemoteException, NotBoundException {
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new SecurityManager());
		}
		
		Registry registry = LocateRegistry.getRegistry("127.0.0.1", 6666);
		      s = (IServer) registry.lookup(Constants.MB_SERVER_NAME);
	}

	@Test
	public void testPingServer() throws RemoteException {
		String msg = s.ping();
		Assert.assertTrue( msg != null);
	}
}
